var Localization = function() {
  var that = this;

  that.data = {
    "English": {
      "WelcomeSignIn": "Sign in to your account",
      "Email": "email",
      "Pass": "password",
      "ForgotPass": "Forgot Password?",
      "CreateAccount": "Create a free user account",
      "ServerUrlPlaceholder": "Please enter your Indigo Server URL",
      "HaveOwnServer": "Have your own server?",
      "DontHaveOwnServer": "I do not have my own server",
      "ErrorUrlRequired": "The Indigo Server URL is required.",
      "ErrorUrlValid": "Please type a valid HTTP or HTTPS URL.",
      "ErrorNotIndigoServer": "Can't reach Indigo Server at this URL.",
      "NewPrototype": "New Prototype",
      "UpdateExisting": "Replace Existing",
      "Description": "Write a brief description",
      "ReviewAndComments": "Review & commenting options",
      "Highlights": "Highlight hotspots and interactions",
      "Comments": "Allow comments",
      "Publish": "Publish",
      "Search": "Search",
      "PublishingPrototype": "Publishing Prototype",
      "UploadedShare": "Published Prototype",
      "EditPrototype": "View in workspace",
      "CreateStudy": "Create usability study",
      "Done": "Done",
      "CopyClipboard": "Link copied to clipboard",
      "By": "by",
      "On": "on",
      "UpgradeText": "Upgrade to use this plugin!",
      "UpgradeTextHref": "Upgrade here",
      "TrialExpired": "Your trial has expired",
      "TryAgain": "Try to open the browser again",
      "NeedLogin": "Please sign in",
      "PublishFirstError": "Replace failed",
      "Synchronizing": "Synchronizing",
      "SyncSuccess": "Synced successfully!",
      "Error": "Error",
      "ShowMore": "Show more",
      "NoArtboardMessage": "You need at least 1 artboard in your Sketch file!",
      "TrialDaysLabel": "Тrial days remaining:",
      "CategoryPhone": "Phone",
      "CategoryTablet": "Tablet",
      "CategoryBrowser": "Browser",
      "CategoryDesktop": "Desktop",
      "CategoryOther": "Other",
      "CustomDevice": "Custom",
      "SignInFailed": "Signing in failed",
      "PublishFirstSecondaryErrorMessage1": "You tried to replace a prototype you haven't published yet.",
      "PublishFirstSecondaryErrorMessage2": "Try publishing instead.",
      "BrowserLoginMessage": "We opened your browser to sign in",
      "SignIn": "Sign in with my own server",
      "CantFindScreen": "You can't find the sign in screen?",
      "GeneratingApp": "Generating your app",
      "Create": "Create App",
      "New Application": "New Application",
      "Retry": "Retry creating an app from current sketch"
    },
    "Japanese": {
      "WelcomeSignIn": "アカウントにログイン",
      "Email": "メールアドレス",
      "Pass": "パスワード",
      "ForgotPass": "パスワードを忘れた",
      "SignIn": "サインイン",
      "CreateAccount": "ユーザーアカウントの作成",
      "ServerUrlPlaceholder": "Indigo サーバーの URL を入力してください。",
      "HaveOwnServer": "サーバーをお持ちですか？",
      "DontHaveOwnServer": "サーバーを持っていません。",
      "ErrorUrlRequired": "Indigo サーバー URL は必須です。",
      "ErrorUrlValid": "有効な http または https で始まる URL を入力してください。",
      "ErrorNotIndigoServer": "この URL の Indigo サーバーが見つかりません。",
      "NewPrototype": "新しいプロトタイプ",
      "UpdateExisting": "既存プロトタイプと置き換え",
      "Description": "簡単な説明を追加",
      "ReviewAndComments": "レビュー & コメント オプション",
      "Highlights": "ホットスポットとインタラクションを強調表示",
      "Comments": "コメントの許可",
      "Publish": "公開",
      "Search": "検索",
      "PublishingPrototype": "プロトタイプの公開",
      "StepAway": "リンクを共有します。",
      "UploadedShare": "公開済みのプロトタイプ",
      "EditPrototype": "ワークスペースで表示",
      "CreateStudy": "ユーザビリティ テストを作成",
      "Done": "OK",
      "CopyClipboard": "コピー完了",
      "By": "作成者:",
      "On": "日付:",
      "UpgradeText": "アップグレードしてプラグインを使用する",
      "UpgradeTextHref": "アップグレード",
      "TrialExpired": "トライアル期間が終了しました。",
      "NeedLogin": "サインインしてください。",
      "PublishFirstError": "置き換えできませんでした。",
      "Synchronizing": "同期しています。",
      "SyncSuccess": "同期が完了しました。",
      "Error": "エラー",
      "Loading": "更に読み込む",
      "ShowMore": "更に表示",
      "NoArtboardMessage": "スケッチファイルに少なくともアートボードが 1 つ必要です。",
      "TrialDaysLabel": "トライアル期間残り日数: ",
      "CategoryPhone": "モバイル",
      "CategoryTablet": "タブレット",
      "CategoryBrowser": "ブラウザー",
      "CategoryDesktop": "デスクトップ",
      "CategoryOther": "その他",
      "CustomDevice": "カスタム",
	    "SignInFailed": "サインインに失敗しました。",
      "PublishFirstSecondaryErrorMessage1": "まだ公開されていないプロトタイプを置き換えることはできません。",
      "PublishFirstSecondaryErrorMessage2": "置き換えではなく公開してください。",
      "BrowserLoginMessage": "サインインするためにブラウザを開きました",
      "SignIn": "自分のサーバーでサインイン",
      "CantFindScreen": "サインイン画面が見つからない場合、",
      "GeneratingApp": "アプリの生成中",
      "Create": "アプリの作成",
      "New Application": "新しいアプリケーション",
      "Retry": "現在のスケッチからアプリを作成し直す",
      "TryAgain": "ブラウザーを再び開いてみてください。"
    }
  };

  that.strings = window.navigator.language.indexOf("ja") == 0 ?
    that.data["Japanese"] :
    that.data["English"];
}

Localization.prototype.getString = function(stringKey) {
  var that = this,
      langKey = "English";

    if (window.navigator.language.indexOf("ja") == 0) {
      langKey = "Japanese";
    }

    return that.data[langKey][stringKey];
}
