var ResourceLoader = function() { }

ResourceLoader.prototype.load = function(filePath) {
    return new Promise(function(resolve, reject) {

        var xhttp = new XMLHttpRequest();
        xhttp.open("GET", filePath, true);
        xhttp.send();

        xhttp.onreadystatechange = function() {
            if (xhttp.readyState == 4) {
                if (xhttp.status == 0 || xhttp.status == 200) {
                    try {
                        var json = JSON.parse(xhttp.response);
                        resolve(json);
                    } catch (e) {
                        resolve(xhttp.response);
                    }
                } else {
                    reject(new Error("Could not load resource file at: " + filePath + ", status: " + xhttp.statusText));
                }
            }
        };
    });
}

ResourceLoader.prototype.loadSet = function(filePaths) {
    if (!(filePaths instanceof Array)) {
        return Promise.reject(new Error("ResourceLoader.loadSet expected an array"));
    }

    var promises = filePaths.map(function(filePath) {
        return ResourceLoader.prototype.load(filePath);
    });

    return Promise.all(promises);
}
