var Completed = function(app) {
  var that = this;
  that.app = app;
}

Completed.prototype.init = function() {
  var that = this,
      copyShareBtn = document.getElementById("copyShareLink"),
      shareUrlInput = document.getElementById("shareUrlInput"),
      infoDialog = document.getElementsByClassName("info-dialog")[0],
      usabilityStudy = document.getElementById("createStudy"),
      editLinkHref = document.getElementById("editLinkHref"),
      prototypeLink = document.getElementById("prototypeLink"),
      pageTitle = document.getElementsByTagName("h2")[0],
      btnsDiv = document.getElementsByClassName("btns")[0];
      doneBtn = document.getElementById("done");

  if (that.app.shareLink){
    shareUrlInput.value = that.app.shareLink;
  }else {
    shareUrlInput.value = that.app.shareId;
  }

  if (that.app.mode == "create"){
    pageTitle.innerHTML = "Published Application"
    usabilityStudy.hidden = true;
    btnsDiv.style.justifyContent = "center";
    btnsDiv.style.alignItems = "center"
  }
  
  copyShareBtn.addEventListener("click", (e) => {
    shareUrlInput.select();
    document.execCommand("copy");
    infoDialog.style.display = "block";

    setTimeout(() => {
      infoDialog.style.display = "none";
    }, 2000);
  }, false);

  editLinkHref.addEventListener("click", (e) => {
    var link = encodeURI(that.app.workspaceUrl);
    window.location.href = "https://localhost/link=" + link;
    e.preventDefault();
  }, false);

  prototypeLink.addEventListener("click", (e) => {
    var link = encodeURI(that.app.shareLink);
    window.location.href = "https://localhost/link=" + link;
    e.preventDefault();
  }, false);

  usabilityStudy.addEventListener("click", (e) => {
    getUsabilityStudyURL(that)
      .then((resultUrl) => {
        var link = encodeURI(resultUrl);
        window.location.href = "https://localhost/link=" + link;
      })
      .catch((err) => {

      });

  }, false);

  doneBtn.addEventListener("click", (e) => {
    that.app.close();
  }, false);
}
