function populateCustomSelect(elementId, data) {
  if (data == null) {
    return;
  }

  var comboContainer = document.getElementById(elementId);
  var selectedItem = comboContainer.querySelector("div");
  var selectItemsContainer = selectedItem.nextElementSibling;

  var categories = data;
  for (var i = 0; i < categories.length; i++) {
    var category = document.createElement("div");
    category.className = "select-items-group";

    var categoryTitle = document.createElement("h4");
    categoryTitle.innerHTML = categories[i].displayName;
    category.appendChild(categoryTitle);

    var selectedCategory = categories[i];
    for (var j = 0; j < selectedCategory.items.length; j++) {
      var item = document.createElement("div");
      item.className = "selectable-dropdown-items";
      item.innerHTML = selectedCategory.items[j].displayName;
      item.setAttribute("data-id", selectedCategory.items[j].id);
      category.appendChild(item);
    }

    selectItemsContainer.appendChild(category);
  }
}

function initializeCustomSelect(elementId, data, valueChanged) {
  var comboContainer = document.getElementById(elementId);
  var selectedItem = comboContainer.querySelector("div");
  var selectItemsContainer = selectedItem.nextElementSibling;

  populateCustomSelect(elementId, data)
  selectedItem.addEventListener("click", (e) => {
    if (selectItemsContainer.style.display == "block") {
      selectItemsContainer.style.display = "none";
      hideBackgroundElement();
    } else {
      selectItemsContainer.style.display = "block";
      showBackgroundElement();
    }
  }, false);

  var items = Array.from(selectItemsContainer.querySelectorAll(".selectable-dropdown-items"));
  items.forEach((item) => {
    item.addEventListener("click", (e) => {
      items.forEach((i) => {
        i.classList.remove("same-as-selected");
      });

      hideBackgroundElement();
      selectItemsContainer.style.display = "none";
      e.target.classList.add("same-as-selected");
      selectedItem.setAttribute("data-id", e.target.getAttribute("data-id"));
      selectedItem.innerHTML = e.target.innerHTML;
      if (valueChanged != null) {
        valueChanged({ text: selectedItem.innerHTML, value: selectedItem.getAttribute("data-id") });
      }
    }, false);
  });

  function showBackgroundElement() {
    var el = document.createElement("div");
    el.classList.add("blocking-background");
    document.body.insertBefore(el, document.body.children[0]);
    el.addEventListener("click", (e) => {
      selectItemsContainer.style.display = "none";
      hideBackgroundElement();
    }, false);
  }

  function hideBackgroundElement() {
    var el = document.getElementsByClassName("blocking-background")[0];
    if (el != null) {
      document.body.removeChild(el);
    }
  }
}

function getSelectedValue(elementId) {

  var comboContainer = document.getElementById(elementId);
  var selectedItem = comboContainer.querySelector("div");

  return selectedItem.getAttribute("data-id");
}

function getSelectedPortSize(elementId) {

  var comboContainer = document.getElementById(elementId);
  var selectedItem = comboContainer.querySelector("div");

  return selectedItem.innerHTML;
}

function setSelectedValue(elementId, value, valueChanged) {

  var comboContainer = document.getElementById(elementId);
  var selectedItem = comboContainer.querySelector("div");
  var selectItemsContainer = selectedItem.nextElementSibling;

  var items = Array.from(selectItemsContainer.querySelectorAll(".selectable-dropdown-items"));
  if (value == null) {
    var defaultSelectedItem = items[0];
    defaultSelectedItem.classList.add("same-as-selected");
    selectedItem.setAttribute("data-id", defaultSelectedItem.getAttribute("data-id"));
    selectedItem.innerHTML = defaultSelectedItem.innerHTML;
  } else {
    items.forEach((item, index) => {
      if (item.getAttribute("data-id") == value) {
        item.classList.add("same-as-selected");
        selectedItem.setAttribute("data-id", value);
        selectedItem.innerHTML = item.innerHTML;
      } else {
        item.classList.remove("same-as-selected");
      }
    });
  }

  if (valueChanged != null) {
    valueChanged({ text: selectedItem.innerHTML, value: selectedItem.getAttribute("data-id") });
  }
}
