var Sync = function(app) {
  var that = this;
  that.app = app;
}

Sync.prototype.init = function() {
  var that = this,
      syncErrorContainer = document.getElementsByClassName("sync-error-container")[0],
      errorDialog = document.getElementsByClassName("error-dialog")[0],
      secondaryErrorDialog = document.getElementsByClassName("secondary-error-dialog")[0],
      syncSuccessContainer = document.getElementsByClassName("sync-success-container")[0],
      sucessDialog = document.getElementsByClassName("success-dialog")[0],
      syncProgressContainer = document.getElementsByClassName("sync-progress-container")[0],
      loadingIndicator = document.querySelector(".Loading.horizontal"),
      syncErrorMsg = document.getElementById("syncErrorMsg"),
      accessToken = localStorage.getItem("iamToken"),
      paramsValue = localStorage.getItem("publishParams"),
      successDone = document.getElementById("successDone"),
      doneBtn = document.getElementById("done");

  successDone.addEventListener("click", (e) => {
    that.app.close();
  }, false);

  doneBtn.addEventListener("click", (e) => {
    if (syncErrorMsg.innerHTML == that.app.localization.strings.PublishFirstError) {
      that.app.loadRootPage("login");
    } else {
      that.app.close();
    }
  }, false);

  if (paramsValue == null) {
    doneBtn.innerHTML = that.app.localization.strings.Publish;

    var secondaryError = "<div>";
    secondaryError += that.app.localization.strings.PublishFirstSecondaryErrorMessage1;
    secondaryError += "</div>";
    secondaryError += "<div>";
    secondaryError += that.app.localization.strings.PublishFirstSecondaryErrorMessage2;
    secondaryError += "</div>";

    showError(that.app.localization.strings.PublishFirstError, secondaryError);
    return;
  }

  var workspaces = JSON.parse(localStorage.getItem("userWorkspaces"));
  var workspaceId = JSON.parse(paramsValue).workspaceId;
  var isWorkspaceActive = workspaces.filter((w) => w.workspaceId == workspaceId);
  if (workspaceId != null && isWorkspaceActive.length == 0) {
    showError(that.app.localization.strings.PublishFirstError);
    return;
  }

  errorDialog.style.display = "none";
  sucessDialog.style.display = "none";
  loadingIndicator.style.display = "block";

  const params = JSON.parse(paramsValue);
  const publishEditor = that.app.pages.publishEditor.model;
  publishEditor.loadAssets(params)
    .then(loadedAssets => {
      accessToken = accessToken ? JSON.parse(accessToken).access_token : JSON.parse(localStorage.getItem("userInfo")).data.token;
      publish(that.app.apiUrl, params, loadedAssets, accessToken)
    })
    .then((r) => {
      loadingIndicator.style.display = "none";
      syncProgressContainer.style.display = "none";
      syncSuccessContainer.style.display = "block";
      sucessDialog.style.display = "block";

      setTimeout(() => {
        that.app.close();
      }, 2000);
    })
    .catch((err) => {
      loadingIndicator.style.display = "none";
      showError(err);
    });

    function showError(err, secondaryError) {
      if (secondaryError) {
        secondaryErrorDialog.innerHTML = secondaryError;
      }

      syncErrorMsg.innerHTML = err;
      syncProgressContainer.style.display = "none";
      syncErrorContainer.style.display = "block";
      errorDialog.style.display = "block";
    }
}
